# yamllint
image: dlek/tester:python-3.11

variables:
  GIT_SUBMODULE_STRATEGY: normal
  PYLINTHOME: /tmp
  TWINE_USERNAME: gitlab-ci-token
  TWINE_PASSWORD: ${CI_JOB_TOKEN}
  TWINE_REPOSITORY_URL: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/pypi
  PACKAGE_NAME: django-dbssin

stages:
  - test
  - build
  - deploy

.test_deps:
  before_script:
    - pip install -r requirements.txt -r tests/requirements.txt

.deploy_deps:
  before_script:
    - pip install -r deploy-requirements.txt

linting:
  stage: test
  extends: .test_deps
  script:
    - tests/test-all --no-unit

dbssin_unit_tests:
  stage: test
  extends: .test_deps
  script:
    - tests/test-all --no-linting

build package:
  stage: build
  extends: .deploy_deps
  script:
    # build for real on a tag commit; otherwise just testing the build
    - export VERSION=${CI_COMMIT_TAG:-0.0.0}
    - sed -i -e 's/version =.*/version = "'$VERSION'"/' pyproject.toml
    - python -m build
  artifacts:
    name: dist
    paths:
      - dist/
    expire_in: 1 hour

publish package:
  stage: deploy
  extends: .deploy_deps
  dependencies:
    - build package
  rules:
    - if: $CI_COMMIT_TAG
  script:
    - python -m twine upload --verbose dist/*
